﻿Imports System
Imports System.Collections.Generic
Imports System.Text
Imports System.Runtime.InteropServices
Imports System.Drawing
Imports System.Windows.Forms.VisualStyles

''' <summary>
''' Provides Windows Operative System specific functionallity.
''' </summary>
Public Module WinApi

#Region "Constants"
   'Listbox constants
   Public Const LB_ADDSTRING As Integer = &H180
   Public Const LB_INSERTSTRING As Integer = &H181
   Public Const LB_DELETESTRING As Integer = &H182
   Public Const LB_RESETCONTENT As Integer = &H184

   'scrollbars
   Public Const SB_LINEUP = 0
   Public Const SB_LINEDOWN = 1

   Public Const WM_NCACTIVATE As Integer = &H86
   Public Const SWP_NOSIZE As Integer = &H1
   Public Const SWP_NOMOVE As Integer = &H2
   Public Const SWP_NOZORDER As Integer = &H4
   Public Const SWP_NOREDRAW As Integer = &H8
   Public Const SWP_NOACTIVATE As Integer = &H10
   Public Const SWP_FRAMECHANGED As Integer = &H20
   ' The frame changed: send WM_NCCALCSIZE
   Public Const SWP_DRAWFRAME As Integer = SWP_FRAMECHANGED
   Public Const SWP_SHOWWINDOW As Integer = &H40
   Public Const SWP_HIDEWINDOW As Integer = &H80
   Public Const SWP_NOCOPYBITS As Integer = &H100
   Public Const SWP_NOOWNERZORDER As Integer = &H200
   ' Don't do owner Z ordering
   Public Const SWP_NOREPOSITION As Integer = SWP_NOOWNERZORDER
   Public Const SWP_NOSENDCHANGING As Integer = &H400
   ' Don't send WM_WINDOWPOSCHANGING

   Public Const WM_MOUSEFIRST As Integer = &H200
   Public Const WM_MOUSEMOVE As Integer = &H200
   Public Const WM_LBUTTONDOWN As Integer = &H201
   Public Const WM_LBUTTONUP As Integer = &H202
   Public Const WM_LBUTTONDBLCLK As Integer = &H203
   Public Const WM_RBUTTONDOWN As Integer = &H204
   Public Const WM_RBUTTONUP As Integer = &H205
   Public Const WM_RBUTTONDBLCLK As Integer = &H206
   Public Const WM_MBUTTONDOWN As Integer = &H207
   Public Const WM_MBUTTONUP As Integer = &H208
   Public Const WM_MBUTTONDBLCLK As Integer = &H209
   Public Const WM_MOUSEWHEEL As Integer = &H20A
   Public Const WM_XBUTTONDOWN As Integer = &H20B
   Public Const WM_XBUTTONUP As Integer = &H20C
   Public Const WM_XBUTTONDBLCLK As Integer = &H20D
   Public Const WM_MOUSELAST As Integer = &H20D

   Public Const WM_KEYDOWN As Integer = &H100
   Public Const WM_KEYUP As Integer = &H101
   Public Const WM_SYSKEYDOWN As Integer = &H104
   Public Const WM_SYSKEYUP As Integer = &H105

   Public Const WM_VSCROLL = &H115

   Public Const VK_SHIFT As Byte = &H10
   Public Const VK_CAPITAL As Byte = &H14
   Public Const VK_NUMLOCK As Byte = &H90

   Private Const DTT_COMPOSITED As Integer = CInt((1 << 13))
   Private Const DTT_GLOWSIZE As Integer = CInt((1 << 11))

   Private Const DT_SINGLELINE As Integer = &H20
   Private Const DT_CENTER As Integer = &H1
   Private Const DT_VCENTER As Integer = &H4
   Private Const DT_NOPREFIX As Integer = &H800

   ''' <summary>
   ''' Enables the drop shadow effect on a window
   ''' </summary>
   Public Const CS_DROPSHADOW As Integer = &H20000

   ''' <summary>
   ''' Windows NT/2000/XP: Installs a hook procedure that monitors low-level mouse input events.
   ''' </summary>
   Public Const WH_MOUSE_LL As Integer = 14

   ''' <summary>
   ''' Windows NT/2000/XP: Installs a hook procedure that monitors low-level keyboard  input events.
   ''' </summary>
   Public Const WH_KEYBOARD_LL As Integer = 13

   ''' <summary>
   ''' Installs a hook procedure that monitors mouse messages.
   ''' </summary>
   Public Const WH_MOUSE As Integer = 7

   ''' <summary>
   ''' Installs a hook procedure that monitors keystroke messages.
   ''' </summary>
   Public Const WH_KEYBOARD As Integer = 2

   ''' <summary>
   ''' The WM_NCLBUTTONUP message is posted when the user releases the left mouse button while the cursor is within the nonclient area of a window. 
   ''' </summary>
   Public Const WM_NCLBUTTONUP As Integer = &HA2

   ''' <summary>
   ''' The WM_SIZE message is sent to a window after its size has changed.
   ''' </summary>
   Public Const WM_SIZE As Integer = &H5

   ''' <summary>
   ''' The WM_ERASEBKGND message is sent when the window background must be erased (for example, when a window is resized).
   ''' </summary>
   Public Const WM_ERASEBKGND As Integer = &H14

   ''' <summary>
   ''' The WM_NCCALCSIZE message is sent when the size and position of a window's client area must be calculated.
   ''' </summary>
   Public Const WM_NCCALCSIZE As Integer = &H83

   ''' <summary>
   ''' The WM_NCHITTEST message is sent to a window when the cursor moves, or when a mouse button is pressed or released.
   ''' </summary>
   Public Const WM_NCHITTEST As Integer = &H84

   ''' <summary>
   ''' The WM_NCMOUSEMOVE message is posted to a window when the cursor is moved within the nonclient area of the window. 
   ''' </summary>
   Public Const WM_NCMOUSEMOVE As Integer = &HA0

   ''' <summary>
   ''' The WM_NCMOUSELEAVE message is posted to a window when the cursor leaves the nonclient area of the window specified in a prior call to TrackMouseEvent.
   ''' </summary>
   Public Const WM_NCMOUSELEAVE As Integer = &H2A2

   ''' <summary>
   ''' An uncompressed format.
   ''' </summary>
   Public Const BI_RGB As Integer = 0

   ''' <summary>
   ''' The BITMAPINFO structure contains an array of literal RGB values.
   ''' </summary>
   Public Const DIB_RGB_COLORS As Integer = 0

   ''' <summary>
   ''' Copies the source rectangle directly to the destination rectangle.
   ''' </summary>
   Public Const SRCCOPY As Integer = &HCC0020

#End Region

#Region "Dll Imports"
   <DllImport("user32.dll")> _
   Private Function RedrawWindow(ByVal hWnd As IntPtr, <[In]()> ByRef lprcUpdate As RECT, ByVal hrgnUpdate As IntPtr, ByVal flags As UInteger) As <MarshalAs(UnmanagedType.Bool)> Boolean
   End Function

   <DllImport("user32.dll")> _
   Private Function RedrawWindow(ByVal hWnd As IntPtr, ByVal lprcUpdate As IntPtr, ByVal hrgnUpdate As IntPtr, ByVal flags As UInteger) As <MarshalAs(UnmanagedType.Bool)> Boolean
   End Function

   <DllImport("user32.dll")> _
   Friend Function SetWindowPos(ByVal hWnd As IntPtr, ByVal hWndInsertAfter As IntPtr, ByVal X As Integer, ByVal Y As Integer, ByVal cx As Integer, ByVal cy As Integer, _
    ByVal uFlags As UInteger) As Boolean
   End Function

   <DllImport("user32")> _
   Friend Function GetCursorPos(ByRef lpPoint As POINT) As Boolean
   End Function

   ''' <summary>
   ''' The ToAscii function translates the specified virtual-key code and keyboard state to the corresponding character or characters.
   ''' </summary>
   ''' <param name="uVirtKey"></param>
   ''' <param name="uScanCode"></param>
   ''' <param name="lpbKeyState"></param>
   ''' <param name="lpwTransKey"></param>
   ''' <param name="fuState"></param>
   ''' <returns></returns>
   <DllImport("user32")> _
   Friend Function ToAscii(ByVal uVirtKey As Integer, ByVal uScanCode As Integer, ByVal lpbKeyState As Byte(), ByVal lpwTransKey As Byte(), ByVal fuState As Integer) As Integer
   End Function

   ''' <summary>
   ''' The GetKeyboardState function copies the status of the 256 virtual keys to the specified buffer.
   ''' </summary>
   ''' <param name="pbKeyState"></param>
   ''' <returns></returns>
   <DllImport("user32")> _
   Friend Function GetKeyboardState(ByVal pbKeyState As Byte()) As Integer
   End Function

   ''' <summary>
   ''' This function retrieves the status of the specified virtual key. The status specifies whether the key is up, down, or toggled on or off — alternating each time the key is pressed. 
   ''' </summary>
   ''' <param name="vKey"></param>
   ''' <returns></returns>
   <DllImport("user32.dll", CharSet:=CharSet.Auto, CallingConvention:=CallingConvention.StdCall)> _
   Friend Function GetKeyState(ByVal vKey As Integer) As Short
   End Function

   ''' <summary>
   ''' Removes a hook procedure installed in a hook chain by the SetWindowsHookEx function. 
   ''' </summary>
   ''' <param name="idHook"></param>
   ''' <returns></returns>
   <DllImport("user32.dll")> _
   Friend Function UnhookWindowsHookEx(ByVal idHook As Integer) As Boolean
   End Function

   ''' <summary>
   ''' Passes the hook information to the next hook procedure in the current hook chain
   ''' </summary>
   ''' <param name="idHook"></param>
   ''' <param name="nCode"></param>
   ''' <param name="wParam"></param>
   ''' <param name="lParam"></param>
   ''' <returns></returns>
   <DllImport("user32.dll")> _
   Friend Function CallNextHookEx(ByVal idHook As Integer, ByVal nCode As Integer, ByVal wParam As IntPtr, ByVal lParam As IntPtr) As Integer
   End Function

   ''' <summary>
   ''' This function retrieves a handle to a display device context (DC) for the client area of the specified window.
   ''' </summary>
   ''' <param name="hdc"></param>
   ''' <returns></returns>
   <DllImport("user32.dll")> _
   Friend Function GetDC(ByVal hdc As IntPtr) As IntPtr
   End Function

   ''' <summary>
   ''' The SaveDC function saves the current state of the specified device context (DC) by copying data describing selected objects and graphic modes
   ''' </summary>
   ''' <param name="hdc"></param>
   ''' <returns></returns>
   <DllImport("gdi32.dll")> _
   Friend Function SaveDC(ByVal hdc As IntPtr) As Integer
   End Function

   ''' <summary>
   ''' This function releases a device context (DC), freeing it for use by other applications. The effect of ReleaseDC depends on the type of device context.
   ''' </summary>
   ''' <param name="hdc"></param>
   ''' <param name="state"></param>
   ''' <returns></returns>
   <DllImport("user32.dll")> _
   Friend Function ReleaseDC(ByVal hdc As IntPtr, ByVal state As Integer) As Integer
   End Function

   ''' <summary>
   ''' Draws text using the color and font defined by the visual style. Extends DrawThemeText by allowing additional text format options.
   ''' </summary>
   ''' <param name="hTheme"></param>
   ''' <param name="hdc"></param>
   ''' <param name="iPartId"></param>
   ''' <param name="iStateId"></param>
   ''' <param name="text"></param>
   ''' <param name="iCharCount"></param>
   ''' <param name="dwFlags"></param>
   ''' <param name="pRect"></param>
   ''' <param name="pOptions"></param>
   ''' <returns></returns>
   <DllImport("UxTheme.dll", CharSet:=CharSet.Unicode)> _
   Private Function DrawThemeTextEx(ByVal hTheme As IntPtr, ByVal hdc As IntPtr, ByVal iPartId As Integer, ByVal iStateId As Integer, ByVal text As String, ByVal iCharCount As Integer, _
    ByVal dwFlags As Integer, ByRef pRect As RECT, ByRef pOptions As DTTOPTS) As Integer
   End Function

   ''' <summary>
   ''' Draws text using the color and font defined by the visual style.
   ''' </summary>
   ''' <param name="hTheme"></param>
   ''' <param name="hdc"></param>
   ''' <param name="iPartId"></param>
   ''' <param name="iStateId"></param>
   ''' <param name="text"></param>
   ''' <param name="iCharCount"></param>
   ''' <param name="dwFlags1"></param>
   ''' <param name="dwFlags2"></param>
   ''' <param name="pRect"></param>
   ''' <returns></returns>
   <DllImport("UxTheme.dll")> _
   Friend Function DrawThemeText(ByVal hTheme As IntPtr, ByVal hdc As IntPtr, ByVal iPartId As Integer, ByVal iStateId As Integer, ByVal text As String, ByVal iCharCount As Integer, _
    ByVal dwFlags1 As Integer, ByVal dwFlags2 As Integer, ByRef pRect As RECT) As Integer
   End Function

   ''' <summary>
   ''' The CreateDIBSection function creates a DIB that applications can write to directly.
   ''' </summary>
   ''' <param name="hdc"></param>
   ''' <param name="pbmi"></param>
   ''' <param name="iUsage"></param>
   ''' <param name="ppvBits"></param>
   ''' <param name="hSection"></param>
   ''' <param name="dwOffset"></param>
   ''' <returns></returns>
   <DllImport("gdi32.dll")> _
   Private Function CreateDIBSection(ByVal hdc As IntPtr, ByRef pbmi As BITMAPINFO, ByVal iUsage As UInteger, ByVal ppvBits As Integer, ByVal hSection As IntPtr, ByVal dwOffset As UInteger) As IntPtr
   End Function

   ''' <summary>
   ''' This function transfers pixels from a specified source rectangle to a specified destination rectangle, altering the pixels according to the selected raster operation (ROP) code.
   ''' </summary>
   ''' <param name="hdc"></param>
   ''' <param name="nXDest"></param>
   ''' <param name="nYDest"></param>
   ''' <param name="nWidth"></param>
   ''' <param name="nHeight"></param>
   ''' <param name="hdcSrc"></param>
   ''' <param name="nXSrc"></param>
   ''' <param name="nYSrc"></param>
   ''' <param name="dwRop"></param>
   ''' <returns></returns>
   <DllImport("gdi32.dll")> _
   Friend Function BitBlt(ByVal hdc As IntPtr, ByVal nXDest As Integer, ByVal nYDest As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal hdcSrc As IntPtr, _
    ByVal nXSrc As Integer, ByVal nYSrc As Integer, ByVal dwRop As UInteger) As Boolean
   End Function

   ''' <summary>
   ''' This function creates a memory device context (DC) compatible with the specified device.
   ''' </summary>
   ''' <param name="hDC"></param>
   ''' <returns></returns>
   <DllImport("gdi32.dll")> _
   Friend Function CreateCompatibleDC(ByVal hDC As IntPtr) As IntPtr
   End Function

   ''' <summary>
   ''' This function selects an object into a specified device context. The new object replaces the previous object of the same type.
   ''' </summary>
   ''' <param name="hDC"></param>
   ''' <param name="hObject"></param>
   ''' <returns></returns>
   <DllImport("gdi32.dll")> _
   Friend Function SelectObject(ByVal hDC As IntPtr, ByVal hObject As IntPtr) As IntPtr
   End Function

   ''' <summary>
   ''' The DeleteObject function deletes a logical pen, brush, font, bitmap, region, or palette, freeing all system resources associated with the object. After the object is deleted, the specified handle is no longer valid.
   ''' </summary>
   ''' <param name="hObject"></param>
   ''' <returns></returns>
   <DllImport("gdi32.dll")> _
   Friend Function DeleteObject(ByVal hObject As IntPtr) As Boolean
   End Function

   ''' <summary>
   ''' The DeleteDC function deletes the specified device context (DC).
   ''' </summary>
   ''' <param name="hdc"></param>
   ''' <returns></returns>
   <DllImport("gdi32.dll")> _
   Friend Function DeleteDC(ByVal hdc As IntPtr) As Boolean
   End Function

   ''' <summary>
   ''' Extends the window frame behind the client area.
   ''' </summary>
   ''' <param name="hdc"></param>
   ''' <param name="marInset"></param>
   ''' <returns></returns>
   <DllImport("dwmapi.dll")> _
   Friend Function DwmExtendFrameIntoClientArea(ByVal hdc As IntPtr, ByRef marInset As MARGINS) As Integer
   End Function

   ''' <summary>
   ''' Default window procedure for Desktop Window Manager (DWM) hit-testing within the non-client area.
   ''' </summary>
   ''' <param name="hwnd"></param>
   ''' <param name="msg"></param>
   ''' <param name="wParam"></param>
   ''' <param name="lParam"></param>
   ''' <param name="result"></param>
   ''' <returns></returns>
   <DllImport("dwmapi.dll")> _
   Friend Function DwmDefWindowProc(ByVal hwnd As IntPtr, ByVal msg As Integer, ByVal wParam As IntPtr, ByVal lParam As IntPtr, ByRef result As IntPtr) As Integer
   End Function

   ''' <summary>
   ''' Obtains a value that indicates whether Desktop Window Manager (DWM) composition is enabled.
   ''' </summary>
   ''' <param name="pfEnabled"></param>
   ''' <returns></returns>
   <DllImport("dwmapi.dll")> _
   Friend Function DwmIsCompositionEnabled(ByRef pfEnabled As Integer) As Integer
   End Function

   ''' <summary>
   ''' Sends the specified message to a window or windows
   ''' </summary>
   ''' <param name="hWnd"></param>
   ''' <param name="Msg"></param>
   ''' <param name="wParam"></param>
   ''' <param name="lParam"></param>
   ''' <returns></returns>
   <DllImport("user32.dll", CharSet:=CharSet.Auto, SetLastError:=False)> _
   Friend Function SendMessage(ByVal hWnd As IntPtr, ByVal Msg As Int32, ByVal wParam As IntPtr, ByVal lParam As IntPtr) As IntPtr
   End Function

#End Region

#Region "Structs"

   ''' <summary>
   ''' Contains information about a mouse event passed to a WH_MOUSE hook procedure
   ''' </summary>
   <StructLayout(LayoutKind.Sequential)> _
   Friend Class MouseLLHookStruct
      Public pt As POINT
      Public mouseData As Integer
      Public flags As Integer
      Public time As Integer
      Public extraInfo As Integer
   End Class

   ''' <summary>
   ''' Contains information about a low-level keyboard input event.
   ''' </summary>
   <StructLayout(LayoutKind.Sequential)> _
   Friend Class KeyboardLLHookStruct
      Public vkCode As Integer
      Public scanCode As Integer
      Public flags As Integer
      Public time As Integer
      Public dwExtraInfo As Integer
   End Class

   ''' <summary>
   ''' Contains information about a mouse event passed to a WH_MOUSE hook procedure
   ''' </summary>
   <StructLayout(LayoutKind.Sequential)> _
   Friend Class MouseHookStruct
      Public pt As POINT
      Public hwnd As Integer
      Public wHitTestCode As Integer
      Public dwExtraInfo As Integer
   End Class

   ''' <summary>
   ''' Represents a point
   ''' </summary>
   Friend Structure POINT
      Public x As Integer
      Public y As Integer
   End Structure

   ''' <summary>
   ''' Defines the options for the DrawThemeTextEx function.
   ''' </summary>
   <StructLayout(LayoutKind.Sequential)> _
   Friend Structure DTTOPTS
      Public dwSize As UInteger
      Public dwFlags As UInteger
      Public crText As UInteger
      Public crBorder As UInteger
      Public crShadow As UInteger
      Public iTextShadowType As Integer
      Public ptShadowOffset As POINT
      Public iBorderSize As Integer
      Public iFontPropId As Integer
      Public iColorPropId As Integer
      Public iStateId As Integer
      Public fApplyOverlay As Integer
      Public iGlowSize As Integer
      Public pfnDrawTextCallback As IntPtr
      Public lParam As Integer
   End Structure

   ''' <summary>
   ''' This structure describes a color consisting of relative intensities of red, green, and blue.
   ''' </summary>
   <StructLayout(LayoutKind.Sequential)> _
   Private Structure RGBQUAD
      Public rgbBlue As Byte
      Public rgbGreen As Byte
      Public rgbRed As Byte
      Public rgbReserved As Byte
   End Structure


   ''' <summary>
   ''' This structure contains information about the dimensions and color format of a device-independent bitmap (DIB).
   ''' </summary>
   <StructLayout(LayoutKind.Sequential)> _
   Private Structure BITMAPINFOHEADER
      Public biSize As Integer
      Public biWidth As Integer
      Public biHeight As Integer
      Public biPlanes As Short
      Public biBitCount As Short
      Public biCompression As Integer
      Public biSizeImage As Integer
      Public biXPelsPerMeter As Integer
      Public biYPelsPerMeter As Integer
      Public biClrUsed As Integer
      Public biClrImportant As Integer
   End Structure

   ''' <summary>
   ''' This structure defines the dimensions and color information of a Windows-based device-independent bitmap (DIB).
   ''' </summary>
   <StructLayout(LayoutKind.Sequential)> _
   Private Structure BITMAPINFO
      Public bmiHeader As BITMAPINFOHEADER
      Public bmiColors As RGBQUAD
   End Structure

   ''' <summary>
   ''' Describes the width, height, and location of a rectangle.
   ''' </summary>
   <StructLayout(LayoutKind.Sequential)> _
   Public Structure RECT
      Public Left As Integer
      Public Top As Integer
      Public Right As Integer
      Public Bottom As Integer
   End Structure

   ''' <summary>
   ''' The NCCALCSIZE_PARAMS structure contains information that an application can use 
   ''' while processing the WM_NCCALCSIZE message to calculate the size, position, and 
   ''' valid contents of the client area of a window. 
   ''' </summary>
   <StructLayout(LayoutKind.Sequential)> _
   Public Structure NCCALCSIZE_PARAMS
      Public rect0 As RECT, rect1 As RECT, rect2 As RECT
      ' Can't use an array here so simulate one
      Public lppos As IntPtr
   End Structure

   ''' <summary>
   ''' Used to specify margins of a window
   ''' </summary>
   <StructLayout(LayoutKind.Sequential)> _
   Friend Structure MARGINS
      Public cxLeftWidth As Integer
      Public cxRightWidth As Integer
      Public cyTopHeight As Integer
      Public cyBottomHeight As Integer

      Public Sub New(ByVal Left As Integer, ByVal Right As Integer, ByVal Top As Integer, ByVal Bottom As Integer)
         Me.cxLeftWidth = Left
         Me.cxRightWidth = Right
         Me.cyTopHeight = Top
         Me.cyBottomHeight = Bottom
      End Sub
   End Structure
#End Region

#Region "Properties"

   ''' <summary>
   ''' Gets if the current OS is Windows NT or later
   ''' </summary>
   Public ReadOnly Property IsWindows() As Boolean
      Get
         Return Environment.OSVersion.Platform = PlatformID.Win32NT
      End Get
   End Property

   ''' <summary>
   ''' Gets a value indicating if operating system is vista or higher
   ''' </summary>
   Public ReadOnly Property IsVista() As Boolean
      Get
         Return IsWindows AndAlso Environment.OSVersion.Version.Major >= 6
      End Get
   End Property

   ''' <summary>
   ''' Gets a value indicating if operating system is xp or higher
   ''' </summary>
   Public ReadOnly Property IsXP() As Boolean
      Get
         Return IsWindows AndAlso Environment.OSVersion.Version.Major >= 5
      End Get
   End Property

   ''' <summary>
   ''' Gets if computer is glass capable and enabled
   ''' </summary>
   Public ReadOnly Property IsGlassEnabled() As Boolean
      Get
         'Check is windows vista
         If IsVista Then
            'Check what DWM says about composition
            Dim enabled As Integer = 0
            Dim response As Integer = DwmIsCompositionEnabled(enabled)

            Return enabled > 0
         End If

         Return False
      End Get
   End Property

#End Region

#Region "Methods"
   Public Sub InvalidateWindow(ByVal hDC As IntPtr)
      'RDW_FRAME
      'RDW_UPDATENOW
      'RDW_INVALIDATE
      RedrawWindow(hDC, IntPtr.Zero, IntPtr.Zero, &H400 Or &H100 Or &H1)
   End Sub

   ''' <summary>
   ''' Invalidates non-client area
   ''' </summary>
   Public Sub InvalidateNC(ByVal hDC As IntPtr)
      WinApi.SetWindowPos(hDC, IntPtr.Zero, 0, 0, 0, 0, _
       WinApi.SWP_NOMOVE Or WinApi.SWP_NOSIZE Or WinApi.SWP_NOZORDER Or WinApi.SWP_NOACTIVATE Or WinApi.SWP_DRAWFRAME)
   End Sub

   ''' <summary>
   ''' Equivalent to the HiWord C Macro
   ''' </summary>
   ''' <param name="dwValue"></param>
   ''' <returns></returns>
   Public Function HiWord(ByVal dwValue As Integer) As Integer
      Return (dwValue >> 16) And &HFFFF
   End Function

   ''' <summary>
   ''' Equivalent to the LoWord C Macro
   ''' </summary>
   ''' <param name="dwValue"></param>
   ''' <returns></returns>
   Public Function LoWord(ByVal dwValue As Integer) As Integer
      Return dwValue And &HFFFF
   End Function

   ''' <summary>
   ''' Equivalent to the MakeLParam C Macro
   ''' </summary>
   ''' <param name="LoWord"></param>
   ''' <param name="HiWord"></param>
   ''' <returns></returns>
   Public Function MakeLParam(ByVal LoWord As Integer, ByVal HiWord As Integer) As IntPtr
      Return New IntPtr((HiWord << 16) Or (LoWord And &HFFFF))
   End Function

   ''' <summary>
   ''' Fills an area for glass rendering
   ''' </summary>
   ''' <param name="g">Graphics object</param>
   ''' <param name="r">drawing rectangle</param>
   Public Sub FillForGlass(ByVal g As Graphics, ByVal r As Rectangle)
      Dim rc As New RECT()
      rc.Left = r.Left
      rc.Right = r.Right
      rc.Top = r.Top
      rc.Bottom = r.Bottom

      Dim destdc As IntPtr = g.GetHdc()
      'hwnd must be the handle of form,not control
      Dim Memdc As IntPtr = CreateCompatibleDC(destdc)
      Dim bitmap As IntPtr
      Dim bitmapOld As IntPtr = IntPtr.Zero

      Dim dib As New BITMAPINFO()
      dib.bmiHeader.biHeight = -(rc.Bottom - rc.Top)
      dib.bmiHeader.biWidth = rc.Right - rc.Left
      dib.bmiHeader.biPlanes = 1
      dib.bmiHeader.biSize = Marshal.SizeOf(GetType(BITMAPINFOHEADER))
      dib.bmiHeader.biBitCount = 32
      dib.bmiHeader.biCompression = BI_RGB
      If Not (SaveDC(Memdc) = 0) Then
         bitmap = CreateDIBSection(Memdc, dib, DIB_RGB_COLORS, 0, IntPtr.Zero, 0)
         If Not (bitmap = IntPtr.Zero) Then
            bitmapOld = SelectObject(Memdc, bitmap)

            BitBlt(destdc, rc.Left, rc.Top, rc.Right - rc.Left, rc.Bottom - rc.Top, Memdc, _
             0, 0, SRCCOPY)
         End If

         'Remember to clean up
         SelectObject(Memdc, bitmapOld)

         DeleteObject(bitmap)

         ReleaseDC(Memdc, -1)


         DeleteDC(Memdc)
      End If

      g.ReleaseHdc()
   End Sub

   ''' <summary>
   ''' Draws theme text on glass.
   ''' </summary>
   ''' <param name="hwnd"></param>
   ''' <param name="text"></param>
   ''' <param name="font"></param>
   ''' <param name="ctlrct"></param>
   ''' <param name="iglowSize"></param>
   ''' <remarks>This method is courtesy of 版权所有 (I hope the name's right)</remarks>
   Public Sub DrawTextOnGlass(ByVal hwnd As IntPtr, ByVal text As [String], ByVal font As Font, ByVal ctlrct As Rectangle, ByVal iglowSize As Integer)
      If IsGlassEnabled Then
         Dim rc As New RECT()
         Dim rc2 As New RECT()

         rc.Left = ctlrct.Left
         rc.Right = ctlrct.Right
         ' +2 * iglowSize;  //make it larger to contain the glow effect
         rc.Top = ctlrct.Top
         rc.Bottom = ctlrct.Bottom
         ' +2 * iglowSize;
         'Just the same rect with rc,but (0,0) at the lefttop
         rc2.Left = 0
         rc2.Top = 0
         rc2.Right = rc.Right - rc.Left
         rc2.Bottom = rc.Bottom - rc.Top

         Dim destdc As IntPtr = GetDC(hwnd)
         'hwnd must be the handle of form,not control
         Dim Memdc As IntPtr = CreateCompatibleDC(destdc)
         ' Set up a memory DC where we'll draw the text.
         Dim bitmap As IntPtr
         Dim bitmapOld As IntPtr = IntPtr.Zero
         Dim logfnotOld As IntPtr

         Dim uFormat As Integer = DT_SINGLELINE Or DT_CENTER Or DT_VCENTER Or DT_NOPREFIX
         'text format
         Dim dib As New BITMAPINFO()
         dib.bmiHeader.biHeight = -(rc.Bottom - rc.Top)
         ' negative because DrawThemeTextEx() uses a top-down DIB
         dib.bmiHeader.biWidth = rc.Right - rc.Left
         dib.bmiHeader.biPlanes = 1
         dib.bmiHeader.biSize = Marshal.SizeOf(GetType(BITMAPINFOHEADER))
         dib.bmiHeader.biBitCount = 32
         dib.bmiHeader.biCompression = BI_RGB
         If Not (SaveDC(Memdc) = 0) Then
            bitmap = CreateDIBSection(Memdc, dib, DIB_RGB_COLORS, 0, IntPtr.Zero, 0)
            ' Create a 32-bit bmp for use in offscreen drawing when glass is on
            If Not (bitmap = IntPtr.Zero) Then
               bitmapOld = SelectObject(Memdc, bitmap)
               Dim hFont As IntPtr = font.ToHfont()
               logfnotOld = SelectObject(Memdc, hFont)
               Try

                  Dim renderer As New VisualStyleRenderer(VisualStyleElement.Window.Caption.Active)

                  Dim dttOpts As New DTTOPTS()

                  dttOpts.dwSize = CUInt(Marshal.SizeOf(GetType(DTTOPTS)))

                  dttOpts.dwFlags = DTT_COMPOSITED Or DTT_GLOWSIZE


                  dttOpts.iGlowSize = iglowSize

                  Dim dtter As Integer = DrawThemeTextEx(renderer.Handle, Memdc, 0, 0, text, -1, _
                   uFormat, rc2, dttOpts)

                  Dim bbr As Boolean = BitBlt(destdc, rc.Left, rc.Top, rc.Right - rc.Left, rc.Bottom - rc.Top, Memdc, _
                   0, 0, SRCCOPY)

                  If Not bbr Then
                     'throw new Exception("???");

                  End If
               Catch e As Exception
                  'throw new Exception("???");
                  Console.WriteLine(e.ToString())
               End Try


               'Remember to clean up
               SelectObject(Memdc, bitmapOld)
               SelectObject(Memdc, logfnotOld)
               DeleteObject(bitmap)
               DeleteObject(hFont)

               ReleaseDC(Memdc, -1)



               DeleteDC(Memdc)
            Else
               'throw new Exception("???");
            End If
         Else
            'throw new Exception("???");



         End If

      End If
   End Sub
#End Region
End Module

